#ifndef BOOK_H
#define BOOK_H

#include <string>
#include <list>

class Book {
public:
  enum SortType {TITLE, AUTHORS, ISBN, YEAR, PUBLISHER, PRICE};
  Book();
  Book(const Book& org);
  Book& operator=(const Book& rhs);
  ~Book();
  bool operator<(const Book& rhs) const;
  bool operator==(const Book& rhs) const;
  bool operator!=(const Book& rhs) const;
  bool operator<=(const Book& rhs) const;
  bool operator>=(const Book& rhs) const;
  bool operator>(const Book& rhs) const;
  std::string getTitle() const;
  void setTitle(const std::string& ttl);
  std::list<std::string> getAuthors() const;
  void setAuthors(const std::list<std::string>& auths);
  long unsigned int getISBN() const;
  void setISBN(const long unsigned int is);
  unsigned int getYear() const;
  void setYear(const unsigned int is);
  std::string getPublisher() const;
  void setPublisher(const std::string& pub);
  double getPrice() const;
  void setPrice(const double prc);
  static void setSortMethod(SortType type);

private:
  std::string title;
  std::list<std::string> authors;
  long unsigned int isbn;
  unsigned int year;
  std::string publisher;
  double price;
  static SortType sortMethod;
};

#endif
